#ifndef _IP_NAT_CORE_H
#define _IP_NAT_CORE_H
#include <linux/list.h>

/* This header used to share core functionality between the standalone
   NAT module, and the compatibility layer's use of NAT for masquerading. */
extern int ip_nat_init(void);
extern void ip_nat_cleanup(void);

extern size_t ip_nat_offset;

extern unsigned int do_binding(struct ip_conntrack_tuple_hash *h,
			       enum ip_conntrack_info conntrackinfo, 
			       struct sk_buff **pskb);

extern struct list_head protos;

extern void icmp_reply_translation(struct sk_buff *skb, 
				   struct ip_conntrack *conntrack,
				   int conn_dir);

extern unsigned int ip_nat_setup_info(struct ip_conntrack *conntrack,
				      enum ip_nat_manip_type maniptype,
				      struct ip_nat_multi_range *mr,
				      const struct net_device *device);

extern void place_in_hashes(struct ip_conntrack *conntrack);

extern void ip_nat_undo(struct ip_conntrack *conntrack);

/* Built-in protocols. */
extern struct ip_nat_protocol ip_nat_protocol_tcp;
extern struct ip_nat_protocol ip_nat_protocol_udp;
extern struct ip_nat_protocol ip_nat_protocol_icmp;
#endif /* _IP_NAT_CORE_H */
