#ifndef _IP_CONNTRACK_CORE_H
#define _IP_CONNTRACK_CORE_H
/* This header is used to share core functionality between the
   standalone connection tracking module, and the compatibility layer's use
   of connection tracking. */
extern unsigned int ip_conntrack_in(unsigned int hooknum,
				    struct sk_buff **pskb,
				    const struct net_device *in,
				    const struct net_device *out);

extern void ip_conntrack_init(void);
extern void ip_conntrack_cleanup(void);

struct ip_conntrack_protocol;
extern struct ip_conntrack_protocol *find_proto(u_int8_t protocol);
extern struct list_head protocol_list;

/* Returns TRUE if it dealt with the skb. */
extern int icmp_error_track(const struct iphdr *iph, size_t len,
			    enum ip_conntrack_info *info, 
			    struct ip_conntrack_tuple_hash **h);
extern int get_tuple(const struct iphdr *iph, size_t len,
		     struct ip_conntrack_tuple *tuple,
		     struct ip_conntrack_protocol *protocol);
#endif /* _IP_CONNTRACK_CORE_H */
