/* Simple kernel module to pass packets out through netfilter. */

#include <linux/config.h>

#include <linux/module.h>
#include <linux/netfilter_ipv4.h>

static int hook = -1;
MODULE_PARM(hook, "i");

/* The work comes in here from netfilter.c. */
static unsigned int
redirect_hook(unsigned int hook,
	      struct sk_buff **pskb,
	      const struct net_device *indev,
	      const struct net_device *outdev)
{
	return NF_QUEUE;
}

static struct nf_hook_ops redir_ops
= { { NULL, NULL }, redirect_hook, NULL, PF_INET, 0, 0 };

int init_module(void)
{
	if (hook < 0 || hook >= NF_IP_NUMHOOKS) {
		printk("Must specify hook=[0-%i]\n", NF_IP_NUMHOOKS-1);
		return -EINVAL;
	}

	redir_ops.hooknum = hook;

	/* Register hook */
	return nf_register_hook(&redir_ops);
}


void
cleanup_module(void)
{
	nf_unregister_hook(&redir_ops);
}
