#! /bin/sh

# Need job control.
set -m

# Test counter zeroing.
../packet-filter/userspace/iptables -A FORWARD -p icmp -j ACCEPT || exit 1
./rcv_ip 2 1 < /dev/tap1 > $TMPFILE &
sleep 1

./gen_ip $TAP0NET.2 $TAP1NET.2 100 1 8 0 55 57 > /dev/tap0
./gen_ip $TAP0NET.2 $TAP1NET.2 50 2 > /dev/tap0

if wait %./rcv_ip; then :
else
    echo ./rcv_ip failed:
    cat $TMPFILE
    exit 1
fi

if [ "`../packet-filter/userspace/iptables -L FORWARD -v`" != "Chain FORWARD (policy DROP 1 packets, 50 bytes)
 pkts bytes target     prot opt tos  in        out       source                destination          
    1   100 ACCEPT     icmp --  0x00 any       any        anywhere              anywhere            " ]
then
    echo Unexpected iptables -L FORWARD counter test.
    iptables -L FORWARD
    exit 1
fi

../packet-filter/userspace/iptables -Z FORWARD || exit 1
if [ "`../packet-filter/userspace/iptables -L FORWARD -v`" != "Chain FORWARD (policy DROP 0 packets, 0 bytes)
 pkts bytes target     prot opt tos  in        out       source                destination          
    0     0 ACCEPT     icmp --  0x00 any       any        anywhere              anywhere            " ]
then
    echo Unexpected iptables -L FORWARD after -Z FORWARD.
    exit 1
fi

exit 0
