#! /bin/sh
# Testing return out thoroughly.

# Need job control.
set -m

# First, a return at the beginning of the FORWARD chain.
../packet-filter/userspace/iptables -A FORWARD -j RETURN || exit 1

# Check listing of forward rule.
if [ "`../packet-filter/userspace/iptables -L FORWARD -v`" != "Chain FORWARD (policy DROP 0 packets, 0 bytes)
 pkts bytes target     prot opt tos  in        out       source                destination          
    0     0 RETURN     all  --  0x00 any       any        anywhere              anywhere            " ]
then
    echo Appending RETURN to FORWARD failed.
    ../packet-filter/userspace/iptables -L FORWARD -v
    exit 1
fi

# Append an ACCEPT rule.
../packet-filter/userspace/iptables -A FORWARD -j ACCEPT || exit 1

# Send packet through (should be denied).
./rcv_ip 2 1 < /dev/tap1 > $TMPFILE &
sleep 1

./gen_ip $TAP0NET.2 $TAP1NET.2 100 1 8 0 55 57 > /dev/tap0 || exit 1

if wait %./rcv_ip
then
    echo ./rcv_ip succeeded:
    cat $TMPFILE
    exit 1
fi

# Try return on user chain.
../packet-filter/userspace/iptables -N test || exit 1
../packet-filter/userspace/iptables -A test -j RETURN || exit 1
../packet-filter/userspace/iptables -A test -j DROP || exit 1

../packet-filter/userspace/iptables -R FORWARD 1 -j test || exit 1

# Send packet through (should be accepted).
./rcv_ip 2 1 < /dev/tap1 > $TMPFILE &
sleep 1

./gen_ip $TAP0NET.2 $TAP1NET.2 100 1 8 0 55 57 > /dev/tap0 || exit 1

if wait %./rcv_ip; then :
else
    echo ./rcv_ip failed:
    cat $TMPFILE
    exit 1
fi

exit 0
