#! /bin/sh

# Test that icmp error packets are recognized as part of same connection.

# Need job control.
set -m

insmod ../test/drop_invalid.o hook=0 || exit 1

for pkt in "$TAP0NET.2 $TAP1NET.2 100 1 8 0 55 57" \
	   "$TAP0NET.2 $TAP1NET.2 100 6 1024 1025 SYN" \
	   "$TAP0NET.2 $TAP1NET.2 100 17 1024 1025" \
	   "$TAP0NET.2 $TAP1NET.2 100 2"
do
    ./gen_ip $pkt > /dev/tap0

    ./rcv_ip 2 21 < /dev/tap0 > $TMPFILE &
    sleep 1

    for i in 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15
    do
	./gen_ip $pkt | ./gen_err $TAP1NET.2 3 $i > /dev/tap1
    done

    for i in "4 0" "11 0" "11 1" "12 0" "12 1"
    do
	./gen_ip $pkt | ./gen_err $TAP1NET.2 $i > /dev/tap1
    done

    if wait %./rcv_ip; then :
    else
	echo ICMPs missing for $pkt
	cat $TMPFILE
	exit 1
    fi
done

rmmod drop_invalid || exit 1
exit 0
