#! /bin/sh

# Test the case where one packet needs to nat over another connection

# Need job control.
set -m

../NAT/userspace/ipnatctl -I -s $TAP0NET.0/24 -d $TAP1NET.2 -b source -t $TAP0NET.100 || exit 1

# Receive 4 packets.
./rcv_ip 2 4 < /dev/tap1 > $TMPFILE &
sleep 1

./gen_ip $TAP0NET.2 $TAP1NET.2 100 17 100 1 > /dev/tap0
./gen_ip $TAP0NET.3 $TAP1NET.2 100 17 100 1 > /dev/tap0
./gen_ip $TAP0NET.4 $TAP1NET.2 100 17 1024 1 > /dev/tap0
./gen_ip $TAP0NET.5 $TAP1NET.2 100 17 1024 1 > /dev/tap0

if wait %./rcv_ip; then :
else
    echo ./rcv_ip failed:
    cat $TMPFILE
    exit 1
fi

for answer in "$TAP0NET.100 $TAP1NET.2 100 17 100 1" \
	      "$TAP0NET.100 $TAP1NET.2 100 17 1 1" \
	      "$TAP0NET.100 $TAP1NET.2 100 17 1024 1" \
	      "$TAP0NET.100 $TAP1NET.2 100 17 1025 1"
do
    read LINE
    if [ "$LINE" != "$answer" ]
    then
	echo Unexpected first answer \`"$LINE"\' vs \`"$answer"\'
	exit 1
    fi
done < $TMPFILE

# Check replies work as expected.
# Receive 4 packets.
./rcv_ip 2 4 < /dev/tap0 > $TMPFILE &
sleep 1

./gen_ip $TAP1NET.2 $TAP0NET.100 100 17 1 100 > /dev/tap1
./gen_ip $TAP1NET.2 $TAP0NET.100 100 17 1 1 > /dev/tap1
./gen_ip $TAP1NET.2 $TAP0NET.100 100 17 1 1024 > /dev/tap1
./gen_ip $TAP1NET.2 $TAP0NET.100 100 17 1 1025 > /dev/tap1

if wait %./rcv_ip; then :
else
    echo ./rcv_ip failed:
    cat $TMPFILE
    exit 1
fi

for answer in "$TAP1NET.2 $TAP0NET.2 100 17 1 100" \
              "$TAP1NET.2 $TAP0NET.3 100 17 1 100" \
              "$TAP1NET.2 $TAP0NET.4 100 17 1 1024" \
              "$TAP1NET.2 $TAP0NET.5 100 17 1 1024"
do
    read LINE
    if [ "$LINE" != "$answer" ]
    then
	echo Unexpected reply answer \`"$LINE"\' vs \`"$answer"\'
	exit 1
    fi
done < $TMPFILE

exit 0


