#! /bin/sh

# Tests for multiple NAT target combinations.

# Need job control.
set -m

../NAT/userspace/ipnatctl -I -s $TAP0NET.2 -d $TAP1NET.0/24 -b source -t $TAP0NET.2 || exit 1
../NAT/userspace/ipnatctl -I -s $TAP0NET.2 -d $TAP1NET.0/24 -b source -t $TAP0NET.3 || exit 1
../NAT/userspace/ipnatctl -I -s $TAP0NET.2 -d $TAP1NET.0/24 -b source -t $TAP0NET.4 || exit 1

# Play with them a bit; delete out of order.
../NAT/userspace/ipnatctl -D -s $TAP0NET.2 -d $TAP1NET.0/24 -b source -t $TAP0NET.3 || exit 1
../NAT/userspace/ipnatctl -D -s $TAP0NET.2 -d $TAP1NET.0/24 -b source -t $TAP0NET.3 2>/dev/null && exit 1
../NAT/userspace/ipnatctl -D -s $TAP0NET.2 -d $TAP1NET.0/24 -b source -t $TAP0NET.4 || exit 1
../NAT/userspace/ipnatctl -D -s $TAP0NET.2 -d $TAP1NET.0/24 -b source -t $TAP0NET.4 2>/dev/null && exit 1
../NAT/userspace/ipnatctl -D -s $TAP0NET.2 -d $TAP1NET.0/24 -b source -t $TAP0NET.2 || exit 1
../NAT/userspace/ipnatctl -D -s $TAP0NET.2 -d $TAP1NET.0/24 -b source -t $TAP0NET.2 2>/dev/null && exit 1

../NAT/userspace/ipnatctl -I -s $TAP0NET.2 -d $TAP1NET.0/24 -b source -t $TAP0NET.2 || exit 1
../NAT/userspace/ipnatctl -I -s $TAP0NET.2 -d $TAP1NET.0/24 -b source -t $TAP0NET.3 || exit 1
../NAT/userspace/ipnatctl -I -s $TAP0NET.2 -d $TAP1NET.0/24 -b source -t $TAP0NET.4 || exit 1

./rcv_ip 2 3 < /dev/tap1 > $TMPFILE &
sleep 1

./gen_ip $TAP0NET.2 $TAP1NET.2 100 1 8 0 55 57 > /dev/tap0
./gen_ip $TAP0NET.2 $TAP1NET.2 100 1 8 0 56 58 > /dev/tap0
./gen_ip $TAP0NET.2 $TAP1NET.2 100 1 8 0 57 59 > /dev/tap0

if wait %./rcv_ip; then :
else
    echo ./rcv_ip failed:
    cat $TMPFILE
    exit 1
fi

# They get done in reverse order at the moment.
for LINE in "$TAP0NET.4 $TAP1NET.2 100 1 8 0 55 57" \
    "$TAP0NET.3 $TAP1NET.2 100 1 8 0 56 58" \
    "$TAP0NET.2 $TAP1NET.2 100 1 8 0 57 59"
do
    read ACTUAL
    if [ "$ACTUAL" != "$LINE" ]
    then
	echo Expected \`"$LINE"\' not \`"$ACTUAL"\'.
	cat $TMPFILE
	exit 1
    fi
done < $TMPFILE

exit 0

