#! /bin/sh

# Script to test ftp module's data mangling

# Need job control.
set -m

insmod ../conntrack/extentions/ip_conntrack_ftp.o || exit 1
insmod ../NAT/extentions/ip_nat_ftp.o || exit 1

# Reverse NAT test.
../NAT/userspace/ipnatctl -I -d $TAP1NET.2 -b dest -t $TAP1NET.3 || exit 1

# Generate initial packets: handshake, then FTP PASV response.
./gen_ip $TAP0NET.2 $TAP1NET.2 100 6 1024 21 SYN > /dev/tap0 || exit 1
./gen_ip $TAP1NET.3 $TAP0NET.2 100 6 21 1024 SYN/ACK > /dev/tap1 || exit 1
./gen_ip $TAP0NET.2 $TAP1NET.2 100 6 1024 21 ACK > /dev/tap0 || exit 1

./rcv_ip 2 1 DATA < /dev/tap0 > $TMPFILE &
sleep 1

echo -e "227 Entering Passive Mode (`echo $TAP1NET.3 | tr . ,`,7,236)\\r" |
./gen_ip $TAP1NET.3 $TAP0NET.2 100 6 21 1024 ACK DATA > /dev/tap1 || exit 1

if wait %./rcv_ip; then :
else
    echo ./rcv_ip failed:
    cat $TMPFILE
    exit 1
fi

if [ "`tr \\\r x < $TMPFILE`" != "$TAP1NET.2 $TAP0NET.2 87 6 21 1024 ACK DATA
227 Entering Passive Mode (`echo $TAP1NET.2 | tr . ,`,7,236)x" ]
then
    echo Unexpected FTP PASV mangling.
    echo \`"`tr \\\r x <  $TMPFILE`"\'
    exit 1
fi

# Force timeout of TCP connections.
./gen_ip $TAP0NET.2 $TAP1NET.2 100 6 1024 21 RST > /dev/tap0 || exit 1
sleep 10

rmmod ip_nat_ftp || exit 1
rmmod ip_conntrack_ftp || exit 1

exit 0
